︠09811bbc-2474-48b8-82e5-b5a48c164235︠
%md
<p>
    In the 2018 Putnam, problem A-2 can be extended to general finite lattices, asking for the value of the determinant of the "meet matrix."  Are there interesting families of lattices for which the matrix is nonsingular?  The diamond poset is somewhat interesting.  Here is the calculation for the 
</p>
︡f9897c25-80a1-45fa-bcd8-3cb0f732499f︡{"done":true,"md":"<p>\n    In the 2018 Putnam, problem A-2 can be extended to general finite lattices, asking for the value of the determinant of the \"meet matrix.\"  Are there interesting families of lattices for which the matrix is nonsingular?\n</p>"}
︠8b255957-7b39-4482-b63d-37662ad6dfcbs︠
    p=Posets.DiamondPoset(6);p
︡15d887cb-4589-49f1-a378-a25ffa5dc486︡{"stdout":"Finite lattice containing 6 elements\n"}︡{"done":true}
︠29907894-6680-4fab-94bd-b4baa5a0591cs︠
p.show(vertex_color="orange")
︡267cada1-54aa-485c-a3e9-972d83bd3f9b︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/122/tmp_lIPd7s.svg","show":true,"text":null,"uuid":"e7f85278-ef8a-4e9a-a36c-8f6786577659"},"once":false}︡{"done":true}
︠a4d5a7c2-7dd1-4dc4-abb8-6c2733b66b3ds︠
q=filter(lambda k:not(k in p.minimal_elements()),p.list());q
︡1b96466b-cb41-41f4-8946-284ce22bcd0c︡{"stdout":"[1, 2, 3, 4, 5]\n"}︡{"done":true}
︠250de503-c6c1-44ee-834e-9e98a3dc7322s︠
def chi(p,i,j):
    if p.meet(i,j) in p.minimal_elements():
        return 0
    else:
        return 1
︡2a53009f-9ffc-4023-81f5-a500ebb5dab5︡{"done":true}
︠94386b4a-6ce1-403b-9447-f44568867d53s︠
A=Matrix(map(lambda k: map(lambda j:chi(p,j,k),q),q));A
︡cab3b310-eda5-4356-89d9-c8dd7c96f059︡{"stdout":"[1 0 0 0 1]\n[0 1 0 0 1]\n[0 0 1 0 1]\n[0 0 0 1 1]\n[1 1 1 1 1]\n"}︡{"done":true}
︠29e99e8e-edf9-4427-9a37-c7bea37773f6s︠
det(A)
︡7c120fbd-97a2-4c0c-b45a-24fb908fad50︡{"stdout":"-3\n"}︡{"done":true}
︠f87fea47-01cd-42cd-b1e0-1da8ffea467ds︠
def poset_d(p):
    q=filter(lambda k:not(k in p.minimal_elements()),p.list())
    A=Matrix(map(lambda k: map(lambda j:chi(p,j,k),q),q))
    return Matrix(A)
︡bfd26b90-6727-47ba-8cde-e051f34a4725︡{"done":true}
︠9e073ef7-df33-40d7-94a8-47076198b5cfs︠
poset_d(Posets.DiamondPoset(8)).det()

︡77029064-a386-42e2-9476-a1554ebc551a︡{"stdout":"-5\n"}︡{"done":true}
︠f80d62d9-f543-4c5f-8ac6-f8042dc7b56bs︠
poset_d(Posets.DiamondPoset(8))
︡7b4204e9-a6db-4fee-a773-2e8da62c66b8︡{"stdout":"[1 0 0 0 0 0 1]\n[0 1 0 0 0 0 1]\n[0 0 1 0 0 0 1]\n[0 0 0 1 0 0 1]\n[0 0 0 0 1 0 1]\n[0 0 0 0 0 1 1]\n[1 1 1 1 1 1 1]\n"}︡{"done":true}
︠b6937701-97a5-4ee3-82ea-e53202d8d79fs︠

︡0309fcfb-a628-41ef-a4af-380c50b56d02︡{"done":true}
︠8f95ed5d-1fda-432f-90ba-26da03b99d7bs︠
n=5
A=Matrix([[i==j or i==n-1 or j==n-1 for i in range(n)] for j in range(n)] )
[A,det(A)]
︡20d6ef95-28a6-44fd-a02c-47bb05f10239︡{"stdout":"[[1 0 0 0 1]\n[0 1 0 0 1]\n[0 0 1 0 1]\n[0 0 0 1 1]\n[1 1 1 1 1], -3]\n"}︡{"done":true}
︠710f6fd6-566d-488e-aeb4-5249dbec272ds︠

︡1815a123-9679-4c0b-b48d-2f99be7da66b︡{"done":true}
︠09a45a70-8e4e-4fcd-85bc-34da654ddf88s︠
map(lambda k:(k,poset_d(Posets.DivisorLattice(k)).det()),range(1,40))
︡397e5bd2-6a89-44ea-8a56-a8ca9f42be4f︡{"stdout":"[(1, 1), (2, 1), (3, 1), (4, 0), (5, 1), (6, -1), (7, 1), (8, 0), (9, 0), (10, -1), (11, 1), (12, 0), (13, 1), (14, -1), (15, -1), (16, 0), (17, 1), (18, 0), (19, 1), (20, 0), (21, -1), (22, -1), (23, 1), (24, 0), (25, 0), (26, -1), (27, 0), (28, 0), (29, 1), (30, -1), (31, 1), (32, 0), (33, -1), (34, -1), (35, -1), (36, 0), (37, 1), (38, -1), (39, -1)]\n"}︡{"done":true}
︠a7de470e-0adb-4c87-b351-5583f80c5586s︠
map(lambda k:(k,poset_d(Posets.DivisorLattice(k)).det()),range(40,80))
︡738b7426-eb25-4bc4-8d8d-b729cc69555b︡{"stdout":"[(40, 0), (41, 1), (42, -1), (43, 1), (44, 0), (45, 0), (46, -1), (47, 1), (48, 0), (49, 0), (50, 0), (51, -1), (52, 0), (53, 1), (54, 0), (55, -1), (56, 0), (57, -1), (58, -1), (59, 1), (60, 0), (61, 1), (62, -1), (63, 0), (64, 0), (65, -1), (66, -1), (67, 1), (68, 0), (69, -1), (70, -1), (71, 1), (72, 0), (73, 1), (74, -1), (75, 0), (76, 0), (77, -1), (78, -1), (79, 1)]\n"}︡{"done":true}
︠40e9447b-068e-47c6-af2c-571dae07a465s︠

︡58896f07-7ee0-4a4d-8095-739c0f8e2d74︡{"done":true}
︠9798f928-cb98-4a0e-b02c-936214bb83e5s︠
map(lambda k:(k,poset_d(Posets.DivisorLattice(k)).det()),[2*3*5*7,2*3*5*7*11,2*3*5*7*7])
︡1345bb00-ff78-4e01-8630-eb87518b7e7f︡{"stdout":"[(210, -1), (2310, -1), (1470, 0)]\n"}︡{"done":true}
︠67d59087-454a-49b1-82d8-aaacde030355︠
︡9e6b8c79-9ace-4e77-96d1-1578a6a7fc75︡{"done":true}︡
︠90734705-b25c-4789-afd4-185cb01d08f0s︠
Posets.YoungsLattice(6).show(vertex_color="orange")
︡589cf11d-7125-4544-89f9-575008fa4747︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/122/tmp_lcCbji.svg","show":true,"text":null,"uuid":"15849341-85c1-4771-b897-1c1650916a0f"},"once":false}︡{"done":true}
︠7e1c3390-cc5f-4e0d-9b00-66b465a7d6be︠
poset_d(Posets.YoungsLattice(5)).det()
︡057027fb-cc98-4796-b107-ba2a16f62e80︡{"stdout":"0\n"}︡{"done":true}︡
︠e4e6778e-2c81-4500-ae34-f81c16adc01d︠
Posets.TamariLattice(4).show(vertex_color="orange")
︡3f915e65-5a3a-4895-b713-08245beabcb3︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/11299/tmp_eYraSK.svg","show":true,"text":null,"uuid":"0ce239e0-9401-4f39-9195-71ae78a5a074"},"once":false}︡{"done":true}︡
︠ea97d73c-eec1-474e-91c6-77338d7131a5︠
poset_d(Posets.TamariLattice(4))
︡fcd11b6f-7908-448c-89fc-146b9c4593e1︡{"stdout":"[1]\n"}︡{"done":true}︡
︠f4c9fe9a-e63d-42c7-9c78-d6e95479246c︠
   poset_d(Posets.IntegerCompositions(5))
︡e6957463-9b10-4ff4-bd05-9cbf76be2d9b︡{"stderr":"Error in lines 0-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1188, in execute\n    flags=compile_flags) in namespace, locals\n  File \"\", line 1, in <module>\n  File \"\", line 3, in poset_d\n  File \"\", line 3, in <lambda>\n  File \"\", line 3, in <lambda>\n  File \"\", line 2, in chi\n  File \"sage/structure/category_object.pyx\", line 853, in sage.structure.category_object.CategoryObject.__getattr__ (build/cythonized/sage/structure/category_object.c:7759)\n    return self.getattr_from_category(name)\n  File \"sage/structure/category_object.pyx\", line 868, in sage.structure.category_object.CategoryObject.getattr_from_category (build/cythonized/sage/structure/category_object.c:7922)\n    attr = getattr_from_other_class(self, cls, name)\n  File \"sage/cpython/getattr.pyx\", line 389, in sage.cpython.getattr.getattr_from_other_class (build/cythonized/sage/cpython/getattr.c:2469)\n    raise AttributeError(dummy_error_message)\nAttributeError: 'FinitePoset_with_category' object has no attribute 'meet'\n"}︡{"done":true}︡
︠d4a4961e-8b88-4bda-a461-bb83d9a76e2a︠





︠be989fb1-72b3-433f-b2d9-78f080d43cca︠









